<?php
/**
 * 侧边栏组件、页面模块
 */
if (!defined('EMLOG_ROOT')) {
	exit('error!');
}
?>
<?php
/**
 * 页顶：导航
 */
function blog_navi() {
	global $CACHE;
	$navi_cache = $CACHE->readCache('navi');
	?>
	<nav class="head-menu">
    <?php
    foreach ($navi_cache as $value):
        if ($value['pid'] != 0) {
            continue;
        }
        $newtab = $value['newtab'] == 'y' ? 'target="_blank"' : '';
        $value['url'] = $value['isdefault'] == 'y' ? BLOG_URL . $value['url'] : trim($value['url'], '/');
        $current_tab = BLOG_URL . trim(Dispatcher::setPath(), '/') == $value['url'] ? 'active' : '';
        ?>
        <?php if (!empty($value['children']) || !empty($value['childnavi'])) : ?>
		<div class="has-child">
        <?php if (!empty($value['children'])): ?>
			<a href="<?php echo $value['url']; ?>"><?php echo $value['naviname']; ?></a>
			<div class="sub-menu">
                <?php foreach ($value['children'] as $row) {
                    echo '<a href="' . Url::sort($row['sid']) . '">' . $row['sortname'] . '</a>';
                } ?>
			</div>
        <?php endif; ?>
        <?php if (!empty($value['childnavi'])): ?>
            <a href="<?php echo $value['url']; ?>"><?php echo $value['naviname']; ?></a>
            <div class="sub-menu">
                <?php foreach ($value['childnavi'] as $row) {
                    $newtab = $row['newtab'] == 'y' ? 'target="_blank"' : '';
                    echo '<a href="' . $row['url'] . "\" $newtab >" . $row['naviname'] . '</a>';
                } ?>
            </div>
        <?php endif; ?>
		</div>
    <?php else: ?>
		<a href="<?php echo $value['url']; ?>"><?php echo $value['naviname']; ?></a>
    <?php endif; ?>
    <?php endforeach; ?>
	</nav>
<?php } ?>
<?php
function trimall($str)//删除空格
{
    $qian = array(" ", "　", "&nbsp;", "\t", "\n", "\r");
    $hou = array("", "", "", "", "");
    return str_replace($qian, $hou, $str);
}
//格式化内容工具
function blog_tool_purecontent($content, $strlen = null){
    $content = str_replace('继续阅读&gt;&gt;', '', strip_tags($content));
    if ($strlen) {
        $content = subString(preg_replace("/\[gsvideo url=(.*) w=(.*) h=(.*)\]/", '', $content), 0, $strlen);
    }
    return $content;
}
?>
<?php
//分页函数
function PageList($count, $perlogs, $page, $url, $anchor = '')
{
    $pnums = @ceil($count / $perlogs);
    $page = @min($pnums, $page);
    $prepg = $page - 1;
    $nextpg = $page == $pnums ? 0 : $page + 1;
    $urlHome = preg_replace("|[\\?&/][^\\./\\?&=]*page[=/\\-]|", "", $url);
    if ($pnums <= 1) {
        return false;
    }
    if ($page != 1) {
        $re .= '<span><a href="'.$urlHome.$anchor.'">«</a></span>';
    }
    for ($i = $page - 2; $i <= $page + 2 && $i <= $pnums; $i++) {
        if ($i > 0) {
            if ($i == $page) {
                $re .= '<span class="current"><a>'.$i.'</a></span>';
            } elseif ($i == 1) {
                $re .= '<span><a href="'.$urlHome.$anchor.'">'.$i.'</a></span>';
            } else {
                $re .= '<span><a href="'.$url.$i.$anchor.'">'.$i.'</a></span>';
            }
        }
    }
    if ($page != $pnums) {
        $re .= '<span><a href="'.$url.$pnums.$anchor.'"></a>»</span>';
    }
    return $re;
}
?>
<?php
//blog-tool:判断是否是首页
function blog_tool_ishome()
{
    if (BLOG_URL . trim(Dispatcher::setPath(), '/') == BLOG_URL) {
        return true;
    } else {
        return FALSE;
    }
}

?>
<?php
//blog：面包屑导航2
function mianbao_lognav($blogid, $log_title)
{
    global $CACHE;
    $log_cache_navi = $CACHE->readCache('logsort');
    ?>
    <?php if (!empty($log_cache_navi[$blogid])): ?>
    <span class="category"><a href="<?php echo Url::sort($log_cache_navi[$blogid]['id']); ?>"><?php echo $log_cache_navi[$blogid]['name']; ?></a></span>
<?php else: ?>
    未分类
<?php endif; ?>
<?php } ?>
<?php
//blog：文章标签
function blog_tag($blogid)
{
    global $CACHE;
    $tag_model = new Tag_Model();

    $log_cache_tags = $CACHE->readCache('logtags');
    if (!empty($log_cache_tags[$blogid])) {
        $tag = '';
        foreach ($log_cache_tags[$blogid] as $value) {
            $tag .= '<a href="' . Url::tag($value['tagurl']) . '" rel="tag">' . $value['tagname'] . '</a>';
        }
        echo $tag;
    } else {
        $tag_ids = $tag_model->getTagIdsFromBlogId($blogid);
        $tag_names = $tag_model->getNamesFromIds($tag_ids);

        if (!empty($tag_names)) {
            $tag = '';

            foreach ($tag_names as $key => $value) {
                $tag .= '<a href="' . Url::tag(rawurlencode($value)) . '" rel="tag">#' . htmlspecialchars($value) . '</a>';
            }

            echo $tag;
        }
    }
}
?>
<?php
//blog：相邻文章
function neighbor_log($neighborLog)
{
    extract($neighborLog); ?>
    <?php if ($prevLog): ?>
    <li>上一篇:
        <a href="<?php echo Url::log($prevLog['gid']) ?>" title="<?php echo $prevLog['title']; ?>"><?php echo $prevLog['title']; ?></a>
    </li>
<?php endif; ?>
    <?php if ($nextLog): ?>
    <li>下一篇:
        <a href="<?php echo Url::log($nextLog['gid']) ?>" title="<?php echo $nextLog['title']; ?>"><?php echo $nextLog['title']; ?></a>
    </li>
<?php endif; ?>
<?php }?>
<?php
/**
 * 文章查看页：评论表单
 */
function blog_comments_post($logid, $ckname, $ckmail, $ckurl, $verifyCode, $allow_remark)
{
    $DB = Database::getInstance();
    $isNeedChinese = Option::get('comment_needchinese');
    if ($allow_remark == 'y'): ?>
        <div class="comment-form" id="respond-post-<?php echo $logid;?>">
            <span class="cancel-comment-reply">
              <a id="cancel-comment-reply-link" href="#respond-post-<?php echo $logid;?>" rel="nofollow" style="display:none" onclick="return TypechoComment.cancelReply();">取消回复</a>
            </span>
            <form method="post" action="<?php echo BLOG_URL; ?>index.php?action=addcom" role="form">
                <div class="row">
        <?php if (ROLE == ROLE_VISITOR): ?>
                    <fieldset class="col-m-6">
                        <input type="text" name="comname" placeholder="网名：" value="<?php echo $ckname; ?>" required>
                        <input type="email" name="commail" placeholder="网箱：" value="<?php echo $ckmail; ?>" required>
                        <input type="url" name="comurl" placeholder="网址：" value="<?php echo $ckurl; ?>">
                    </fieldset>
        <?php endif; ?>
                    <fieldset class="col-m-6">
                  <textarea rows="3" name="comment" id="comment" placeholder="人工审核机制，就别浪费您的复制与粘贴了，走好不送..." required="" onkeydown="if(event.ctrlKey&&event.keyCode==13){document.getElementById('misubmit').click();return false};"></textarea>
                        <button type="submit" class="btn" id="misubmit">提交评论(Ctrl+Enter)</button>
                    </fieldset>
                </div>
                <input type="hidden" name="gid" value="<?php echo $logid; ?>" id="comment_post_ID">
                <input type="hidden" name="pid" id="comment_parent" value="0">
            </form>
        </div>
    <?php endif; ?>
<?php } ?>
<?php
/**
 * 文章查看页：评论列表
 */
function blog_comments($comments)
{
    extract($comments);
    $comnum = count($comments);
    if ($commentStacks): ?>
        <div class="comment-list">
    <?php endif; ?>
    <?php
    $isGravatar = Option::get('isgravatar');

    foreach ($commentStacks as $cid):
        global $CACHE;
        $DB = Database::getInstance();
        $comment = $comments[$cid];
        $user_cache = $CACHE->readCache('user');
        $userinfo = $user_cache[$comment['uid']];
        if ($comment['uid'] == 0) {
            $username = $comment['poster'];
        } else {
            $username = $userinfo['name'];
        }
        if (empty($userinfo['avatar'])) {
            $photo = '//q2.qlogo.cn/headimg_dl?dst_uin=' . $comment['mail'] . '&spec=100';
        } else {
            $photo = BLOG_URL . $userinfo['avatar'];
        }
        if ($userinfo['role'] == 'admin') {
            $role = '<span style="background-color:#fd5d3c;color:#ffffff;padding: 1px 5px;margin-right:5px;border-radius:3px">管理员</span>';
        } elseif ($userinfo['role'] == 'writer') {
            $role = '<span style="background-color:#348be8;color:#ffffff;padding: 1px 5px;margin-right:5px;border-radius:3px">普通用户</span>';
        } else {
            $role = '<span style="background-color:#ccc;color:#ffffff;padding: 1px 5px;margin-right:5px;border-radius:3px">游客</span>';
        }
        $nicknameurl = '<a href="' . $comment['url'] . '" target="_blank" rel="external nofollow" target="_blank">' . $username . '</a>';
        ?>
        <div class="comment-single " id="comment-<?php echo $comment['cid']; ?>">
            <img class="avatar" src="<?php echo $photo; ?>?s=150&amp;r=G&amp;d=robohash" alt="<?php echo $username ?>" width="150" height="150" />
            <div class="comment-meta">
                <span class="comment-author">
                    <?php echo $nicknameurl; ?>&nbsp;&nbsp;<?php echo $_SERVER['HTTP_USER_AGENT'];?>
                <time class="comment-time"><?php echo $comment['date']; ?></time>
                <span class="comment-reply">
                  <a href="#comment-page-1?replyTo=<?php echo $comment['cid']; ?>#respond-post-<?php echo $comment['gid']; ?>" rel="nofollow" onclick="return TypechoComment.reply('comment-<?php echo $comment['cid']; ?>', <?php echo $comment['cid']; ?>);">
                    <i class="fa fa-reply" title="回复">
                    </i>
                  </a>
                </span>
            </div>
            <div class="comment-content">
                <p><?php echo $comment['content']; ?></p>
            </div>
        </div>
        <?php blog_comments_children($comments, $comment['children']); ?>
    <?php endforeach; ?>
    </div>
    <section class="page-navigator">
        <?php echo $commentPageUrl; ?>
    </section>
<?php } ?>
<?php
/**
 * 文章查看页：子评论
 */
function blog_comments_children($comments, $children)
{
    $isGravatar = Option::get('isgravatar');
    foreach ($children as $child):
        global $CACHE;
        $comment = $comments[$child];
        $user_cache = $CACHE->readCache('user');
        $userinfo = $user_cache[$comment['uid']];
        if ($comment['uid'] == 0) {
            $username = $comment['poster'];
        } else {
            $username = $userinfo['name'];
        }
        $nicknameurl = '<a href="' . $comment['url'] . '" target="_blank" rel="external nofollow" target="_blank">' . $username . '</a>';
        if (empty($userinfo['avatar'])) {
            $photo = '//q2.qlogo.cn/headimg_dl?dst_uin=' . $comment['mail'] . '&spec=100';
        } else {
            $photo = BLOG_URL . $userinfo['avatar'];
        }
        if ($userinfo['role'] == 'admin') {
            $role = '<span style="background-color:#fd5d3c;color:#ffffff;padding: 1px 5px;margin-right:5px;border-radius:3px">管理员</span>';
        } elseif ($userinfo['role'] == 'writer') {
            $role = '<span style="background-color:#348be8;color:#ffffff;padding: 1px 5px;margin-right:5px;border-radius:3px">普通用户</span>';
        } else {
            $role = '<span style="background-color:#ccc;color:#ffffff;padding: 1px 5px;margin-right:5px;border-radius:3px">游客</span>';
        }
        ?>
        <div class="comment-single  comment-child" id="comment-<?php echo $comment['cid']; ?>">
            <img class="avatar" src="<?php echo $photo; ?>?s=150&amp;r=G&amp;d=robohash" alt="<?php echo $userinfo ?>" width="150" height="150">
            <div class="comment-meta">
                <span class="comment-author">
                  <?php echo $nicknameurl; ?>&nbsp;&nbsp;
                            <time class="comment-time"><?php echo $comment['date']; ?></time>
                            <span class="comment-reply">
                  <a href="#comment-page-1?replyTo=<?php echo $comment['cid']; ?>#respond-post-<?php echo $comment['gid']; ?>" rel="nofollow" onclick="return TypechoComment.reply('comment-<?php echo $comment['cid']; ?>', <?php echo $comment['cid']; ?>);">
                    <i class="fa fa-reply" title="回复">
                    </i>
                  </a>
                </span>
            </div>
            <div class="comment-content">
                <p><?php echo $comment['content']; ?></p>
            </div>
        </div>
        <?php blog_comments_children($comments, $comment['children']); ?>
    <?php endforeach; ?>
<?php } ?>
<?php
/**
 * 文章页作者头像
 */
function author_phone($uid) {
    global $CACHE;
    $user_cache = $CACHE->readCache('user');
    $author = $user_cache[$uid]['name'];
    if (empty($user_cache[$uid]['avatar'])) {
        $photo = TEMPLATE_URL . 'images/default.png';
    } else {
        $photo = BLOG_URL . $user_cache[$uid]['avatar'];
    }
    echo '<figure class="author-avatar"><img src="'.$photo.'?s=200&amp;r=X&amp;d=" alt="Paul" width="200" height="200"></figure>';
}
?>
